|
||||||||||
| PREV CLASS NEXT CLASS | FRAMES NO FRAMES | |||||||||
| SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD | |||||||||
java.lang.Objectcom.atlassian.jira.issue.fields.AbstractField
com.atlassian.jira.issue.fields.AbstractOrderableField
com.atlassian.jira.issue.fields.WorklogSystemField
public class WorklogSystemField
A field representation of logging work.
This allows JIRA administrators to place the "Log Work" field on screens. This means that JIRA users can now log
work whilst creating, editing or transitioning issues. The field works in a similar way to the
CommentSystemField in that while it implements the "getEditHtml" method, previously entered work logs cannot
be edited. In effect, the only functionality available is to "add" more work logs.
The WorklogService is used to do the hard work of validating and creating the work logs from user input.
WorklogService| Nested Class Summary | |
|---|---|
static interface |
WorklogSystemField.WorklogValue
A value object used to aggregate all the transient values required in taking input from the UI, validating it and creating the resultant work logs. |
| Field Summary | |
|---|---|
static String |
PARAM_ISCREATEISSUE
|
static String |
PARAM_ISDELETELOG
|
static String |
PARAM_ISEDITLOG
|
static String |
WORKLOG_ACTIVATE
|
static String |
WORKLOG_ADJUSTESTIMATE
|
static String |
WORKLOG_ADJUSTMENTAMOUNT
|
static String |
WORKLOG_DESCRIPTION
|
static String |
WORKLOG_ID
|
static String |
WORKLOG_NEWESTIMATE
|
static String |
WORKLOG_STARTDATE
|
static String |
WORKLOG_TIMELOGGED
|
static String |
WORKLOG_VISIBILITY_LEVEL
|
| Fields inherited from class com.atlassian.jira.issue.fields.AbstractField |
|---|
authenticationContext |
| Fields inherited from interface com.atlassian.jira.issue.fields.OrderableField |
|---|
MOVE_ISSUE_PARAM_KEY, NO_HEADER_PARAM_KEY, TEMPLATE_DIRECTORY_PATH |
| Constructor Summary | |
|---|---|
WorklogSystemField(VelocityTemplatingEngine templatingEngine,
ApplicationProperties applicationProperties,
JiraAuthenticationContext authenticationContext,
PermissionManager permissionManager,
CommentSearchHandlerFactory searchHandlerFactory,
ComponentLocator componentLocator,
GroupManager groupManager,
DateTimeFormatterFactory dateTimeFormatterFactory,
JiraBaseUrls jiraBaseUrls)
|
|
| Method Summary | |
|---|---|
String |
availableForBulkEdit(BulkEditBean bulkEditBean)
Determines whether the field is available for bulk editing given the BulkEditBean. |
boolean |
canRemoveValueFromIssueObject(Issue issue)
Returns true if a call to OrderableField.removeValueFromIssueObject(com.atlassian.jira.issue.MutableIssue)
will actually remove the value. |
SearchHandler |
createAssociatedSearchHandler()
Return SearchHandler for the field. |
void |
createValue(Issue issue,
Object newValue)
Create the value of the issue in the data store. |
String |
getCreateHtml(FieldLayoutItem fieldLayoutItem,
OperationContext operationContext,
webwork.action.Action action,
Issue issue,
Map displayParameters)
Returns the HTML that should be shown when the issue is being created. |
Object |
getDefaultValue(Issue issue)
The value that should be set on the issue if the field is not shown for some reason. |
String |
getEditHtml(FieldLayoutItem fieldLayoutItem,
OperationContext operationContext,
webwork.action.Action action,
Issue issue,
Map displayParameters)
Returns HTML that should be shown when the issue is being edited. |
FieldTypeInfo |
getFieldTypeInfo(FieldTypeInfoContext fieldTypeInfoContext)
Returns lower level Information about the field. |
JsonData |
getJsonDefaultValue(IssueContext issueCtx)
Return The default data for this system field. |
FieldJsonRepresentation |
getJsonFromIssue(Issue issue,
boolean renderedVersionRequested,
FieldLayoutItem fieldLayoutItem)
Return a FieldJsonDataPair containing a json representation of the raw data for this field, and if required, a json representation of the rendered data for easy display. |
JsonType |
getJsonSchema()
Return a description of the shape of this field when represented as JSON. |
protected Object |
getRelevantParams(Map<String,String[]> inputParameters)
Defines the object that will be passed through to the create method |
RestFieldOperationsHandler |
getRestFieldOperation()
|
String |
getValueFromIssue(Issue issue)
Gets the value stored for this field on the provided issue. |
Object |
getValueFromParams(Map params)
Get a field value from the map of parameters passed. |
String |
getViewHtml(FieldLayoutItem fieldLayoutItem,
webwork.action.Action action,
Issue issue,
Map displayParameters)
|
String |
getViewHtml(FieldLayoutItem fieldLayoutItem,
webwork.action.Action action,
Issue issue,
Object value,
Map displayParameters)
|
boolean |
hasValue(Issue issue)
Determines if the field has a value for the given issue. |
boolean |
isRenderable()
Defines if a field determines itself as renderable. |
boolean |
isShown(Issue issue)
Tests field specific way to determine if it should be shown or not. |
MessagedResult |
needsMove(Collection originalIssues,
Issue targetIssue,
FieldLayoutItem targetFieldLayoutItem)
Used to determine if the field needs input from user to be moved to the new project and/or issue type. |
void |
populateDefaults(Map<String,Object> fieldValuesHolder,
Issue issue)
Populate the fieldValueHolder with a value that should be shown by default when the issue has not been created yet. |
void |
populateForMove(Map<String,Object> fieldValuesHolder,
Issue originalIssue,
Issue targetIssue)
Used to populate the fieldValueHolder with parameters for move issue screen. |
void |
populateFromIssue(Map<String,Object> fieldValuesHolder,
Issue issue)
Used to initialise the fieldValuesHolder from the current value of teh issue. |
void |
populateParamsFromString(Map<String,Object> fieldValuesHolder,
String stringValue,
Issue issue)
Used to convert from a user friendly string value and put the result into the fieldValuesHolder. |
void |
removeValueFromIssueObject(MutableIssue issue)
Removes the field value from the given MutableIssue object. |
void |
updateIssue(FieldLayoutItem fieldLayoutItem,
MutableIssue issue,
Map fieldValueHolder)
Sets the value as a modified external field in the issue so that this field will be updated along with all the other modified issue values. |
void |
updateValue(FieldLayoutItem fieldLayoutItem,
Issue issue,
ModifiedValue modifiedValue,
IssueChangeHolder issueChangeHolder)
Update the issue in the data store. |
void |
validateParams(OperationContext operationContext,
ErrorCollection errorCollectionToAddTo,
I18nHelper i18n,
Issue issue,
FieldScreenRenderLayoutItem fieldScreenRenderLayoutItem)
Ensure that the parameters are valid |
| Methods inherited from class com.atlassian.jira.issue.fields.AbstractOrderableField |
|---|
getApplicationProperties, getBulkEditHtml, getCreateHtml, getEditHtml, getPermissionManager, getVelocityParams, getVelocityParams, getViewHtml, hasBulkUpdatePermission, hasParam, hasPermission, isHidden, populateFromParams, rendererTypesEqual, renderTemplate, valuesEqual |
| Methods inherited from class com.atlassian.jira.issue.fields.AbstractField |
|---|
compareTo, equals, getAuthenticationContext, getId, getName, getNameKey, hashCode |
| Methods inherited from class java.lang.Object |
|---|
clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait |
| Methods inherited from interface com.atlassian.jira.issue.fields.OrderableField |
|---|
getBulkEditHtml, getCreateHtml, getEditHtml, getViewHtml, hasParam, populateFromParams |
| Methods inherited from interface com.atlassian.jira.issue.fields.Field |
|---|
getId, getName, getNameKey |
| Methods inherited from interface java.lang.Comparable |
|---|
compareTo |
| Methods inherited from interface com.atlassian.jira.issue.fields.renderer.RenderableField |
|---|
getId |
| Field Detail |
|---|
public static final String WORKLOG_TIMELOGGED
public static final String WORKLOG_STARTDATE
public static final String WORKLOG_NEWESTIMATE
public static final String WORKLOG_ADJUSTMENTAMOUNT
public static final String WORKLOG_ADJUSTESTIMATE
public static final String WORKLOG_ACTIVATE
public static final String WORKLOG_ID
public static final String WORKLOG_DESCRIPTION
public static final String WORKLOG_VISIBILITY_LEVEL
public static final String PARAM_ISCREATEISSUE
public static final String PARAM_ISEDITLOG
public static final String PARAM_ISDELETELOG
| Constructor Detail |
|---|
public WorklogSystemField(VelocityTemplatingEngine templatingEngine,
ApplicationProperties applicationProperties,
JiraAuthenticationContext authenticationContext,
PermissionManager permissionManager,
CommentSearchHandlerFactory searchHandlerFactory,
ComponentLocator componentLocator,
GroupManager groupManager,
DateTimeFormatterFactory dateTimeFormatterFactory,
JiraBaseUrls jiraBaseUrls)
| Method Detail |
|---|
public SearchHandler createAssociatedSearchHandler()
SearchableFieldSearchHandler for the field. This object tells JIRA how to search for values within the field.
createAssociatedSearchHandler in interface SearchableFieldcreateAssociatedSearchHandler in class AbstractOrderableFieldnull when no searcher
is associated with the field. This will mainly happen when a customfield is configured to have no
searcher.protected Object getRelevantParams(Map<String,String[]> inputParameters)
getRelevantParams in class AbstractOrderableFieldinputParameters - is a representation of the request params that are available
WorklogSystemField.WorklogValue
public void validateParams(OperationContext operationContext,
ErrorCollection errorCollectionToAddTo,
I18nHelper i18n,
Issue issue,
FieldScreenRenderLayoutItem fieldScreenRenderLayoutItem)
OrderableField
validateParams in interface OrderableFieldoperationContext - OperationContexterrorCollectionToAddTo - ErrorCollection to add to.i18n - I18nHelperissue - This is passed to get the value of other fields that may or may not have been modified.fieldScreenRenderLayoutItem - FieldScreenRenderLayoutItem
public String getCreateHtml(FieldLayoutItem fieldLayoutItem,
OperationContext operationContext,
webwork.action.Action action,
Issue issue,
Map displayParameters)
OrderableField
getCreateHtml in interface OrderableFieldfieldLayoutItem - FieldLayoutItemoperationContext - OperationContextaction - Actionissue - IssuedisplayParameters - Map of display parameters.
public String getEditHtml(FieldLayoutItem fieldLayoutItem,
OperationContext operationContext,
webwork.action.Action action,
Issue issue,
Map displayParameters)
OrderableField
getEditHtml in interface OrderableFieldfieldLayoutItem - FieldLayoutItemoperationContext - OperationContextaction - Actionissue - IssuedisplayParameters - Map of display parameters.
public String getViewHtml(FieldLayoutItem fieldLayoutItem,
webwork.action.Action action,
Issue issue,
Map displayParameters)
getViewHtml in interface OrderableField
public String getViewHtml(FieldLayoutItem fieldLayoutItem,
webwork.action.Action action,
Issue issue,
Object value,
Map displayParameters)
getViewHtml in interface OrderableFieldpublic boolean isShown(Issue issue)
OrderableField
isShown in interface OrderableFieldissue - The Issue.
public void populateDefaults(Map<String,Object> fieldValuesHolder,
Issue issue)
OrderableField
populateDefaults in interface OrderableFieldfieldValuesHolder - The fieldValuesHolder Map to be populated.issue - The Issue.
public void populateFromIssue(Map<String,Object> fieldValuesHolder,
Issue issue)
OrderableField
populateFromIssue in interface OrderableFieldfieldValuesHolder - The fieldValuesHolder Map to be populated.issue - The Issue.public Object getDefaultValue(Issue issue)
OrderableFieldFor example: The user does not have permission to see the field, or the field is not part of the create screen.
getDefaultValue in interface OrderableFieldissue - the Issue.
public void createValue(Issue issue,
Object newValue)
OrderableField
createValue in interface OrderableFieldissue - Issue this field is part ofnewValue - Value to store in this field (eg. Collection for Version fields). Cannot be null.
public void updateValue(FieldLayoutItem fieldLayoutItem,
Issue issue,
ModifiedValue modifiedValue,
IssueChangeHolder issueChangeHolder)
OrderableFieldFields that are simply stored in the JIRAISSUE DB table, need not do anything here as this table is written to one time to include all fields that changed. Fields using other DB tables must update that table with the appropriate values.
updateValue in interface OrderableFieldfieldLayoutItem - for this field within this contextissue - Issue this field is part ofmodifiedValue - new value to set field to. Cannot be null.issueChangeHolder - an object to record any changes made to the issue by this method.
public void updateIssue(FieldLayoutItem fieldLayoutItem,
MutableIssue issue,
Map fieldValueHolder)
updateIssue in interface OrderableFieldfieldLayoutItem - FieldLayoutItemissue - MutableIssuefieldValueHolder - Field Value Holder MapOrderableField.updateValue(com.atlassian.jira.issue.fields.layout.field.FieldLayoutItem, com.atlassian.jira.issue.Issue, com.atlassian.jira.issue.ModifiedValue, com.atlassian.jira.issue.util.IssueChangeHolder)
public MessagedResult needsMove(Collection originalIssues,
Issue targetIssue,
FieldLayoutItem targetFieldLayoutItem)
OrderableField
needsMove in interface OrderableFieldoriginalIssues - Collection of original Issues.targetIssue - Target Issue.targetFieldLayoutItem - FieldLayoutItem
public void populateForMove(Map<String,Object> fieldValuesHolder,
Issue originalIssue,
Issue targetIssue)
OrderableFieldOrderableField.needsMove(java.util.Collection,com.atlassian.jira.issue.Issue,com.atlassian.jira.issue.fields.layout.field.FieldLayoutItem)
returned true, and the remote user (the one performing the move) has the permission to actually update this field.
populateForMove in interface OrderableFieldfieldValuesHolder - Map of field Values.originalIssue - orignal IssuetargetIssue - target Issuepublic void removeValueFromIssueObject(MutableIssue issue)
OrderableFieldNote that this operation does not actually persist the change, it just clears the value from the given Issue object. The caller will still need to call #updateValue() in order to persist the change.
Some Fields may choose to quietly ignore this request. eg The SecurityLevel Field will not remove Security Level from subtasks because the subtask must always take the Security Level of its parent issue.
removeValueFromIssueObject in interface OrderableFieldissue - The issue object to be effected.OrderableField.canRemoveValueFromIssueObject(com.atlassian.jira.issue.Issue),
OrderableField.updateValue(com.atlassian.jira.issue.fields.layout.field.FieldLayoutItem, com.atlassian.jira.issue.Issue, com.atlassian.jira.issue.ModifiedValue, com.atlassian.jira.issue.util.IssueChangeHolder)public boolean canRemoveValueFromIssueObject(Issue issue)
OrderableFieldtrue if a call to OrderableField.removeValueFromIssueObject(com.atlassian.jira.issue.MutableIssue)
will actually remove the value.
There a few different reasons why this method may return false:
canRemoveValueFromIssueObject in interface OrderableFieldissue - The Issue object.
true if a call to OrderableField.removeValueFromIssueObject(com.atlassian.jira.issue.MutableIssue)
will actually remove the value.OrderableField.removeValueFromIssueObject(com.atlassian.jira.issue.MutableIssue)public boolean hasValue(Issue issue)
OrderableField
hasValue in interface OrderableFieldissue - the Issue.
public Object getValueFromParams(Map params)
throws FieldValidationException
OrderableField
getValueFromParams in interface OrderableFieldparams - the map of parameters.
FieldValidationException - if there is a problem with Field Validation.
public void populateParamsFromString(Map<String,Object> fieldValuesHolder,
String stringValue,
Issue issue)
throws FieldValidationException
OrderableField
populateParamsFromString in interface OrderableFieldfieldValuesHolder - Map of field Values.stringValue - user friendly string valueissue - the Issue
FieldValidationException - if cannot convert to a value from the given stringpublic String availableForBulkEdit(BulkEditBean bulkEditBean)
OrderableField
availableForBulkEdit in interface OrderableFieldbulkEditBean - holds the state of the bulk-edit wizard (e.g. the selected issues for bulk editing)
null if the field is available for bulk-editing or an i18n key of the error message to show as
why the field is not available.public String getValueFromIssue(Issue issue)
RenderableField
getValueFromIssue in interface RenderableFieldissue - identifies the issue that will contain the value for this field.
public boolean isRenderable()
RenderableField
isRenderable in interface RenderableFieldpublic RestFieldOperationsHandler getRestFieldOperation()
getRestFieldOperation in interface RestFieldOperationspublic JsonData getJsonDefaultValue(IssueContext issueCtx)
RestFieldOperations
getJsonDefaultValue in interface RestFieldOperationsissueCtx - Issue (This should really only need to be an issue context, but for historical reasons we need an issue object.public FieldTypeInfo getFieldTypeInfo(FieldTypeInfoContext fieldTypeInfoContext)
RestAwareField
getFieldTypeInfo in interface RestAwareFieldfieldTypeInfoContext - the FieldTypeInfoContext contains context information that is relevant to generate the FieldTypeInfopublic JsonType getJsonSchema()
RestAwareField
getJsonSchema in interface RestAwareField
public FieldJsonRepresentation getJsonFromIssue(Issue issue,
boolean renderedVersionRequested,
@Nullable
FieldLayoutItem fieldLayoutItem)
RestAwareField
getJsonFromIssue in interface RestAwareFieldissue - to get field data fromrenderedVersionRequested - whether the use requested the return of rendered/pretty data as well as raw datafieldLayoutItem - field layout for this field. Will only be supplied if the field is also an ordereable field.
|
||||||||||
| PREV CLASS NEXT CLASS | FRAMES NO FRAMES | |||||||||
| SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD | |||||||||